const fs = require('fs')
let moment = require('moment-timezone')
let _ = require('lodash')
const uuid = require('uniqid')
let all = []
init()


async function init() {


    let arr = []
    let files = await fs.readdirSync('E:\\fail\\btc1')
    let files2 = await fs.readdirSync('E:\\fail\\btc2')
    let files3 = await fs.readdirSync('E:\\fail\\btc3')
    files=formatByLp(files)
    files2=formatByLp(files2)
    files3=formatByLp(files3)
    files=_.shuffle(files)
    let newFiles=[]
    for (let i=0;i<files.length;i++)
    {
        let lp=files[i].lp
        let files2Name=''


        for (let j=0;j<files2.length;j++)
            if (files2[j].lp ===lp)
                files2Name=files2[j].fileName
        if (files2Name ==='')
        {
            console.log('Cant find lp',lp,' in Both ')
            continue
        }
        let files3Name=''
        for (let j=0;j<files3.length;j++)
            if (files3[j].lp ===lp)
                files3Name=files3[j].fileName
        if (files3Name ==='')
            newFiles.push({file1Name:files[i].fileName,file2Name:files2Name,lp:lp})

    }
   // console.log(newFiles)
    let newArr2=[]
    for (let i=0;i<1000;i++)
        if (i<(newFiles.length-1))
        newArr2.push(newFiles[i])
    console.log(newArr2)

    for (let i = 0; i < newArr2.length; i++) {
        // if (!files[i].includes('.csv'))
        //     continue
        arr.push(read('E:\\fail\\btc1\\' + newArr2[i].file1Name, newArr2[i].file1Name))
        arr.push(read('E:\\fail\\btc2\\' + newArr2[i].file2Name, newArr2[i].file2Name))
    }


    // for (let i = 0; i < files2.length; i++) {
    //     if (!files2[i].includes('.csv'))
    //         continue
    //     arr.push(read('E:\\fail\\btc2\\' + files2[i], files2[i]))
    // }

    arr = await Promise.all(arr)
    // console.log(arr)
    for (let i = 0; i < arr.length; i++)
        arrange(arr[i])
    //  console.log(arr[0].arr[0])
    manage()
    print()
      //console.log(all[0].data)

    //  console.log(files)
    // let com = await fs.readFileSync('E:\\fail\\btc1', 'utf8');
    // com = JSON.parse(com)


}
function formatByLp(files)
{
    let arr=[]
    for (let i=0;i<files.length;i++)
    {
        let name  = files[i].split('_')
        let uniq = name[4] + '_' + name[5]
        uniq = uniq.replace('.csv', '')

        arr.push({fileName:files[i],lp:uniq})
    }
    return arr

}

async function print()
{
    for (let i=0;i<all.length;i++)
    {
        let text='Ticket,Open_Time,Type,Symbol,Open_Price,Close_Price,Close_Time,dPrfPipWrtOpPrPc,dAgeHiPrfInPrPc_RunUpPc,dAgeLoPrfInPrPc_DrawDownPc\n'
       let data=all[i].data
        for (let j=0;j<data.length;j++)
        {
            let currentSide=data[j].data[2]
 try {
     let nextSide=data[j+1].data[2]
     if (typeof  nextSide !=="undefined" && nextSide !==currentSide)
     {
         text=text+data[j].text
         if (j !==data.length-1)
             text=text+'\n'
     }


 }catch (e)
 {

 }

        }

      //  console.log(text)
        printFile(all[i].uniq,text)
    }
}

function manage() {
    for (let i = 0; i < all.length; i++) {
        let data = all[i].data
        data = _.uniqBy(data, 'time');
        data = _.orderBy(data, 'time');
        let arrs=[]

        let t=''
        for (let z = 0; z < data.length; z++) {
            let s=data[z].data
            for (let j=0;j<s.length;j++)
            {
                let t=(z+1)+','+s[1]+','+s[2]+','+s[3]+','+s[4]+','+s[5]+','+s[6]+','+s[7]+','+s[8]+','+s[9]
                data[z].text=t
            }
        }

      //  console.log(data)
        all[i].data = data


    }


}

async function arrange(data) {
    for (let i = 0; i < all.length; i++)
        if (all[i].uniq === data.uniq) {
            for (let j = 0; j < data.arr.length; j++)
                all[i].data.push(data.arr[j])
            return
        }

    all.push({uniq: data.uniq, data: data.arr})
}


async function read(dir, name) {
    let arr = []
    let com = await fs.readFileSync(dir, 'utf8');
    com = com.split('\n')
    name = name.split('_')
    let uniq = name[4] + '_' + name[5]
    uniq = uniq.replace('.csv', '')
    console.log(uniq)
    let start=1
    if (dir.includes('btc2'))
        start=2
    //  console.log(com.length)
    for (let i = start; i < com.length; i++) {
        let pars = com[i].split(',')
        let obj = {}
        obj.time = pars[1]
        if (typeof obj.time === "undefined")
            continue
        obj.data = pars
        arr.push(obj)

    }

    // console.log(uniq,arr)
    return {uniq, arr}
    //  console.log(com)
    // com = JSON.parse(com)
}

function isUpper(str) {
    return !/[a-z]/.test(str) && /[A-Z]/.test(str);
}

function capital(t) {
    let f = ''
    for (let j = 0; j < t.length; j++)
        if (isUpper(t[j]))
            f = f + t[j]

    return f
}

function printFile(name,data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile('E:\\fail\\btc3\\'+name+'.csv', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function createComResfileADV(data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile(pairs + 'newCom.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function found(pair, lp) {
    for (let i = 0; i < res.length; i++) {
        if (!res[i].includes(lp + '_'))
            continue


        let d = res[i].split(',')
        let timeframe = d[13]
        timeframe = timeframe.split(' ')
        let newTimeframe = '0d '
        for (let z = 1; z < timeframe.length; z++) {
            newTimeframe = newTimeframe + timeframe[z]
            if (z !== timeframe.length - 1)
                newTimeframe = newTimeframe + ' '
        }
        timeframe = newTimeframe
        let pvt = parseFloat(d[14])
        let factor = parseFloat(d[15])
        let period = d[106]
        period = period.split(pair)
        period = parseFloat(period[period.length - 1])
        let name = d[106]

        return {name, timeframe, pvt, factor, period}

    }
}


